* Make "make install-strip" works properly, and "make install"
[rsync/rsync.git] / runtests.sh
index 5d3af1b..50f4c8b 100755 (executable)
@@ -139,6 +139,16 @@ echo "$0 running in `pwd`"
 echo "    rsync_bin=$rsync_bin"
 echo "    srcdir=$srcdir"
 
+if testuser=`whoami`
+then
+    :
+else 
+    testuser='(unknown)'
+fi
+
+echo "    testuser=$testuser"
+echo "    os=`uname -a`"
+
 if test ! -f $rsync_bin
 then
     echo "rsync_bin $rsync_bin is not a file" >&2
@@ -176,8 +186,8 @@ prep_scratch() {
     return 0
 }
 
-discard_scratch() {
-    [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+maybe_discard_scratch() {
+    [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
     return 0
 }
 
@@ -191,7 +201,6 @@ do
     testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
     scratchdir="$scratchbase.$testbase"
 
-    echo "----- $testbase starting"
     prep_scratch
 
     set +e
@@ -199,21 +208,33 @@ do
     result=$?
     set -e
 
+    if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
+    then
+       echo "----- $testbase log follows"
+       cat "$scratchdir/test.log"
+       echo "----- $testbase log ends"
+    fi
+
     case $result in
     0)
-       echo "----- $testbase completed successfully"
+       echo "PASS    $testbase"
        passed=`expr $passed + 1`
-       discard_scratch
+       maybe_discard_scratch
        ;;
     77)
-       echo "----- $testbase skipped"
+       echo "SKIP    $testbase"
        skipped=`expr $skipped + 1`
-       discard_scratch
+       maybe_discard_scratch
+       ;;
+    78)
+        # It failed, but we expected that.  don't dump out error logs, 
+       # because most users won't want to see them.  But do leave
+       # the working directory around.
+       echo "XFAIL   $testbase"
+       failed=`expr $failed + 1`
        ;;
     *)
-       echo "----- $testbase failed: log follows"
-       cat "$scratchdir/test.log"
-       echo "----- $testbase log ends"
+       echo "FAIL    $testbase"
        failed=`expr $failed + 1`
        if [ "x$nopersist" = "xyes" ]
        then